addpath(['..\program'])
rng(0);
Ind.it=90000; %number of iterations
Ind.it0=40000; %burn-in phase
Ind.rth=5; % save every rth draw
%        MMC=3000; %retained moments for bayes factor
Ind.perm=2; % flag (1) to order the factors according to the number of sign. loadings
%      (2) to randomly permute the factors
Ind.sperm=1; %flag to randomly switch factor sign (0) check positivity
Ind.bf=0; %flag to retain the posterior moments of the model parameters
Ind.bfm=0;
Ind.prior=2; %prior on factor loadings: 0: normal (hierarchical); 1: one-layer sparse; 2:two-layer sparse;

Ind.psilag=2; % autocorrelation length of idiosyncratic component
Ind.philag=1; % autocorrelation length of common factor
Ind.f_ind=0;  % flag for diagonal factor VAR process
Ind.const=0; %flag to include a constant
m_adj=1;  %flag to demean data
s_adj=1;  %flag to standardize data (implemented only with m_adj=1 together)

Ind.norm=1; %flag to use 'switching' algorithm (sampling f_t based on lambda'lambda=D)
Ind.utz=0; %flag to impose upper triangular zero loadings (only in combination with norm=0)

%read data
base_dir='..\';
File.data_dir=[base_dir 'data\'];
File.results_dir='C:\matlab\sparfac\KAD\';%[base_dir 'results\KAD\1706\'];%'C:\kaufmann\matlab\sparfac\results\KAD\1706\';
mkdir(File.results_dir)
File.file='kadfull_';
file1='macro_data_full_sample_period';
file2='CPI_145_indices_d11.xls';

%file='simsparsedat0906_II';
test=0;
data_read_kad %out y

%y=xt;

Ind.N=size(Data.y,2);
Ind.nobs=size(Data.y,1);  %full sample length
Ind.nvars=size(Data.y,2); %number of variables

for nf=16;
    Ind.nf=nf;
    specify_prior % out: tau0 (nfx2), beta0=(a0,b0) (nfx2, if prior==2) rho0=(r0,s0) (nfx2, if prior>0),
    % p0 (nf^2*philagx1), P0inf ((nf^2*philag)x(nf^2*philag)),
    % q0 (nvarsxpsilag) Q0inf(psilagxpsilagxnvars),
    % sigeps0=(u0,U0) (nvarsx2)
    if ~test
        initialize_values % out: lam (nvarsxnf), lamstar(?), phistar(nfxnf*philag), psi(nvarsxpsilag), sigeta (nfxnf)
        % sigeps (nvarsx1), beta (nvarsxnf), rho (nfx1) tau (nfx1)
    end
    tic
    
    [Mc,~]=mcmc_sparfac(Data.y,Ini,Priors,Ind,File);
    
    toc
    File.resultsfile=[File.file 's_prior' int2str(Ind.prior) '_perm' int2str(Ind.perm) '_sperm' int2str(Ind.sperm) '_tau' num2str(Priors.tau0(1,2),'%4.2f') '_rho0' num2str(Priors.rho0(1,1),'%5.2f') '_b0' num2str(Priors.beta0(1,2),'%5.2f') '_nf' int2str(Ind.nf) '_philag' int2str(Ind.philag) '_psilag' int2str(Ind.psilag) '_norm' int2str(Ind.norm) '_utz' int2str(Ind.utz)];
    save([File.results_dir File.resultsfile],'Mc','Priors','Ind','Data','File')
%     if Ind.bf
%         save([File.results_dir File.file '_post_prior' int2str(Ind.prior) '_perm' int2str(Ind.perm) '_sperm' int2str(Ind.sperm) '_tau' num2str(Priors.tau0(1,2),'%4.2f') '_rho0' num2str(Priors.rho0(1,1),'%5.2f') '_b0' num2str(Priors.beta0(1,2),'%5.2f') '_Ind.nf' int2str(nf) '_Ind.philag' int2str(philag) '_Ind.psilag' int2str(psilag) '_norm' int2str(Ind.norm) '_utz' int2str(Ind.utz)],...
%             'Post')
%     end
end



