set(0,'DefaultAxesFontSize',14,'DefaultAxesFontName','Arial');
set(0,'DefaultFigureWindowStyle','docked')
%factor identification:
% 1. collect the highly correlated factor draws (the number of correlated draws should be larger than sigdr*Ndraws, sigdr=0.9)
%      to form a first mean of common patterns
%    Define: cor_lev: the minimum correlation to group draws to a pattern
%            cor_bnd: the lowest correlation to group patterns across factor places
%
% the factor patterns are saved in ftstmed (T x nfpat)
% 2. if the number of patterns has to be reduced to nf, the patterns are saved into ftstmed_red

% 3. if nfpat=nf: run permute_factors
%    if nfpat<nf: run permute_factors_ext
%    if nfpat>nf: run permute_factors_group


MMC_o=size(ftmcstar,3);
nf_o=size(ftmcstar,2);
T=size(ftmcstar,1);
ftmcstar_o=ftmcstar;
lamstar_o=lamstarmc;
ftmcstar=reshape(ftmcstar,T,1,(nf_o)*MMC_o);
lamstarmc=reshape(lamstarmc,size(lamstarmc,1),1,(nf_o)*MMC_o);
nf=size(ftmcstar,2);
MMC=size(ftmcstar,3);

cor_lev=0.7;
cor_bnd=0.6;

factors=[1:nf];
%it_ref=zeros(1,nf);
it0=0;
intg=5;
drf=1;
int=1;%ceil((MMC-it0)/mit);
index=[it0+1:int:MMC];
n_med=length(index);
sigdr=n_med/nf_o*0.9;
ind_med=1:n_med;
it_ref=struct([]);
sel=struct([]);
it_sel=struct([]);
c_mat=struct([]);fac_ind=struct([]);
Cof_mat=[];
Col_mat=[];

% 1. collect the highly correlated factor simulations to form a first mean of common patterns
ftst=struct([]);
for k=1:nf
    k
    ind_med=index;
    r=1;
    cr=1;
    ftst(k).co(1)=0;
    while length(ind_med)>sigdr
        co_mat=corr(ftmcstar(:,k,ind_med(1)),permute(ftmcstar(:,k,ind_med),[1 3 2]));
        %corr(lamstarmc(:,k,ind_med(1)),permute(lamstarmc(:,k,ind_med),[1 3 2]));
        [cox,coy]=hist(co_mat',[-0.95:0.1:0.95]);
        Cof_mat=cat(2,Cof_mat,cox');
        [cox,coy]=hist(corr(lamstarmc(:,k,ind_med(1)),permute(lamstarmc(:,k,ind_med),[1 3 2])),[-0.95:0.1:0.95]);
        Col_mat=cat(2,Col_mat,cox');
        if drf
            figure(3)
            scatter(co_mat(1:intg:end),(cr-1)*ones(1,length(co_mat(1:intg:end))));
            hold on
            pause(0.01)
        end
        ind_co=abs(co_mat)>cor_lev;
        ftst(k).co(1,cr)=sum(ind_co);ftst(k).co(2,cr)=median(abs(co_mat(ind_co)));cr=cr+1;
        if drf
            figure(2)
            bar(ftst(k).co(1,1:cr-1))
            hold on
            scatter([1:cr-1],ftst(k).co(2,1:cr-1)*10000,'filled','r')
            pause(0.01)
        end
        while (sum(ind_co)<=sigdr)
            ind_med(ind_co)=0;
            ind_med=ind_med(find(ind_med));
            if length(ind_med)<=sigdr
                break
            end
            co_mat=corr(ftmcstar(:,k,ind_med(1)),permute(ftmcstar(:,k,ind_med),[1 3 2]));
            %corr(lamstarmc(:,k,ind_med(1)),permute(lamstarmc(:,k,ind_med),[1 3 2]));
            [cox,coy]=hist(co_mat',[-0.95:0.1:0.95]);
            Cof_mat=cat(2,Cof_mat,cox');
            [cox,coy]=hist(corr(lamstarmc(:,k,ind_med(1)),permute(lamstarmc(:,k,ind_med),[1 3 2])),[-0.95:0.1:0.95]);
            Col_mat=cat(2,Col_mat,cox');
            if drf
                figure(3)
                scatter(co_mat(1:intg:end),(cr-1)*ones(1,length(co_mat(1:intg:end))));
                hold on
                pause(0.01)
            end
            %corr(lamstarmc(:,k,ind_med(1)),permute(lamstarmc(:,k,ind_med),[1 3 2]));
            ind_co=abs(co_mat)>cor_lev;
            ftst(k).co(1,cr)=sum(ind_co);ftst(k).co(2,cr)=median(abs(co_mat(ind_co)));cr=cr+1;
        end
        if length(ind_med)<=sigdr
            break
        end
        ftst(k).pat(:,r)=mean(permute(ftmcstar(:,k,ind_med(ind_co)),[1 3 2]).*kron(ones(T,1),sign(co_mat(ind_co))),2);
        ind_med(ind_co)=0;
        ind_med=ind_med(find(ind_med));
        r=r+1;
    end
end
% figure(3)
% h=gca;
% cr=h.YLim(2);
close 2
cr=min(find(ftst.co(1,:)>sigdr,1,'last')+1);
figure(2)
bar(ftst(k).co(1,1:cr-1))
hold on
scatter([1:cr-1],ftst(k).co(2,1:cr-1)*10000,'filled','r')
xlabel('clustering iteration')
ylabel('number of clustered factor draws')
hold on
plot(1:cr-1,sigdr*(ones(cr-1,1)))

ax=gca;
y_lab=strcat(int2str((1:cr-1)'), ': |J^1|=', int2str(ftst(k).co(1,1:cr-1)'));
figure(5)
bar3(coy,Cof_mat(:,1:cr-1))
title('Factors')
legend(y_lab)
figure(6)
bar3(coy,Col_mat(:,1:cr-1))
legend(y_lab)
title('Loadings')

ftstmed=[];
ftstpat=[];
for k=1:size(ftst,2)
    ftstmed=cat(2,ftstmed,ftst(k).pat);
end



% 3. if the number of extracted patterns is higher than the number of estimated factors: reduce those patterns which are most correlated with
%     other ones (to keep mostly independent factor patterns
mco=[];
nft=size(ftstmed,2);
if size(ftstmed,2)>nf
    co_mat=corr(ftstmed);
    for j=2:nft
        mco(j)=max(abs(co_mat(1:j-1,j)));
    end
    [mco_new,si]=sort(mco);
    ind_ft=si(1:nf);
    ftstmed_red=ftstmed(:,ind_ft);
end

nf=nf_o;
MMC=MMC_o;
ftmcstar=ftmcstar_o;
lamstarmc=lamstar_o;


clear ftstpat ind_med n_med